#!/bin/bash

#ylabel='Volume mixing ratio'
#ylabel='Concentration (molecules\/cm3)'
ylabel='Concentration or vmr'

legends='S1_S2_S3_S4_S5_S6_S7'

PREF=
dirdata2=
fileform2=ZSPEC.dat

while getopts ":p:d:n:c:m:e:f:s:t:y:l:" option
do
  case "$option" in
    p) PREF=$OPTARG
    ;;
    d) dirdata1=$OPTARG
    ;;
    n) subtitle1="$(echo $OPTARG | sed -e 's/_/ /g' )"
    ;;
    f) fileform1=$OPTARG
    ;;
    c) dirdata2=$OPTARG
    ;;
    m) subtitle2="$(echo $OPTARG | sed -e 's/_/ /g' )"
    ;;
    e) fileform2=$OPTARG
    ;;
    s) SPEC=$OPTARG
    ;;
    t) title="$(echo $OPTARG | sed -e 's/_/ /g' )"
    ;;
    y) ylabel="$(echo $OPTARG | sed -e 's/_/ /g' )"
    ;;
    l) legends=$OPTARG
    ;;
  esac
done

#echo "run for $dirdata1 ~~ $subtitle1 ~~ $fileform1"

if [ "A$dirdata2" == 'A' ] ; then
 p2='no'
else
 p2='yes'
fi



if [ "A$title" == 'A' ] ; then
 title=$SPEC
fi

S1=$(echo $legends | cut -d '_' -f1 )
S2=$(echo $legends | cut -d '_' -f2 )
S3=$(echo $legends | cut -d '_' -f3 )
S4=$(echo $legends | cut -d '_' -f4 )
S5=$(echo $legends | cut -d '_' -f5 )
S6=$(echo $legends | cut -d '_' -f6 )
S7=$(echo $legends | cut -d '_' -f7 )


file1=$(echo $fileform1 | sed -e "s/SPEC/$SPEC/g" )
BLOCK="-block ${dirdata1}/$file1 -bxy 1:"

echo "....................................... $SPEC  / $file1"

ncol=`head -1 ${dirdata1}/$file1 | wc -w`
#echo "    $ncol "


if [ $p2 == 'yes' ] ; then
file2=$(echo $fileform2 | sed -e "s/SPEC/$SPEC/g" )
CBLOCK="-block ${dirdata2}/$file2 -bxy 1:"
subtitle="$subtitle1 vs $subtitle2"

else

CBLOCK="-block ${dirdata1}/$file1 -bxy 1:"
subtitle="$subtitle1"

fi

icol=2
while [ $icol -le $ncol ] ; do
PLOT="$PLOT ${BLOCK}$icol ${CBLOCK}$icol "
let icol=icol+1
done



sed -e "s/REPLACETITLE/$title/" cexplot.par  \
| sed -e "s/REPLACEYLABEL/$ylabel/"  \
| sed -e "s/REPLACECOMPARE/$subtitle/"  \
| sed -e "s/S1/$S1/"  \
| sed -e "s/S2/$S2/"  \
| sed -e "s/S3/$S3/"  \
| sed -e "s/S4/$S4/"  \
| sed -e "s/S5/$S5/"  \
| sed -e "s/S6/$S6/"  \
| sed -e "s/S7/$S7/"  \
> myplot.par


#xmgrace \
gracebat -p myplot.par \
 -graph 0 \
 -autoscale xy \
 $PLOT \
 -printfile ${dirdata1}/${PREF}${file1/'.dat'/'.eps'} -hardcopy 

convert -density 200x200 -rotate 90 ${dirdata1}/${PREF}${file1/'.dat'/'.eps'}  ${dirdata1}/${PREF}${file1/'.dat'/'.jpg'}

