! GMRES SOLUTION
      subroutine GMRESSOL(a,rhs,sol,n,m,lwork,icntl,cntl,info,rinfo)
*
      integer , intent(in) :: n, m, lwork
      double precision , intent(in) :: a(n,n), rhs(n)
      double precision , intent(inout) :: sol(n)
      integer , intent(in) :: icntl(8)
      double precision  , intent(in) :: cntl(5)
      integer , intent(out) :: info(3)
      double precision  , intent(out) :: rinfo(2)
*
*   local
      double precision :: work(lwork)
      integer revcom, colx, coly, colz, nbscal
      integer irc(5)
*
      integer matvec, precondLeft, precondRight, dotProd
      parameter (matvec=1, precondLeft=2, precondRight=3, dotProd=4)
*
      double precision ZERO, ONE
      parameter (ZERO = 0.0d0, ONE = 1.0d0)

!! SAVE_GMRES
       integer :: iterOut_save
       integer :: jH_save
       double precision :: beta_save
       double precision :: bn_save
       double precision :: dnormres_save
       integer :: retlbl_save
       integer :: j_save
       double precision :: sA_save
       double precision :: sb_save
       double precision :: sPA_save 
       double precision :: sPb_save
       double precision :: dnormx_save
       double precision :: trueNormRes_save
       double precision :: bea_save 
       double precision :: be_save
       double precision :: be2_save
       double precision :: dloo_save
       integer :: nOrtho_save 
       integer :: compRsd_save
!
       iterOut_save=0
       jH_save=0
       beta_save=0.
       bn_save=0.
       dnormres_save=0.
       retlbl_save=0
       j_save=0
       sA_save=0.
       sb_save=0.
       sPA_save=0.
       sPb_save=0.
       dnormx_save=0.
       trueNormRes_save=0.
       bea_save=0.
       be_save=0.
       be2_save=0.
       dloo_save=0.
       nOrtho_save=0 
       compRsd_save=0


*
      work(1:n)=sol
      work(n+1:2*n)=rhs

*****************************************
** Reverse communication implementation
*****************************************
      retlbl_save=0
*
10     call drive_dgmres(n,n,m,lwork,work,
     &         irc,icntl,cntl,info,rinfo,
     &         iterOut_save, jH_save, beta_save, bn_save, 
     &         dnormres_save, retlbl_save, j_save,
     &         sA_save, sb_save, sPA_save, sPb_save, dnormx_save, 
     &         trueNormRes_save, bea_save, be_save, be2_save,
     &         dloo_save, nOrtho_save, compRsd_save)
       revcom = irc(1)
       colx   = irc(2)
       coly   = irc(3)
       colz   = irc(4)
       nbscal = irc(5)
*
       !write(*,*) '........... out drive_dgmres',info(2),revcom
       if (revcom.eq.matvec) then
* perform the matrix vector product
*        work(colz) <-- A * work(colx)
         call dgemv('N',n,n,ONE,a,n,work(colx),1,
     &            ZERO,work(colz),1)
         goto 10
*
       else if (revcom.eq.precondLeft) then
* perform the left preconditioning
*         work(colz) <-- M^{-1} * work(colx)
          do i=0,n-1
            work(colz+i) = work(colx+i)/a(i+1,i+1)
          enddo  
c    preconditionnement par triangulaire inferieure. A VERIFIER
c        call dcopy(n,work(colx),1,work(colz),1)
c        call dtrsm('L','L','N','N',n,1,ONE,A,n,work(colz),n)
         goto 10
*
       else if (revcom.eq.precondRight) then
* perform the right preconditioning			OK?
          do i=0,n-1
            work(colz+i) = work(colx+i)/a(i+1,i+1)
          enddo  
cc    preconditionnement par triangulaire superieure. A VERIFIER
c         call dcopy(n,work(colx),1,work(colz),1)
c         call dtrsm('L','U','N','N',n,1,ONE,A,n,work(colz),n)
         goto 10
*
       else if (revcom.eq.dotProd) then
*      perform the scalar product
*      work(colz) <-- work(colx) work(coly)
*
         call dgemv('C',n,nbscal,ONE,work(colx),n,
     &               work(coly),1,ZERO,work(colz),1)
         goto 10
       endif
*
      sol=work(1:n)
*
*
      end
