!  ASIS method 0D Fortran code demonstrator
!
!  Reference:
!    ASIS v1.0: an adaptative solver for the simulation of atmospheric chemistry
!    Daniel Cariolle, Philippe Moinat, Hubert Teyssèdre, Luc Giraud, Béatrice Josse, and Franck Lefèvre
!    Geosci. Model Dev. Discuss., doi:10.5194/gmd-2016-281, 2016
!    Manuscript accepted for publication in the journal Geosci. Model Dev.
!    Published: 21 November 2016
!
!  PHYSICAL CONSTANTS
!
MODULE cstphy_module

USE TYPES, ONLY : JPIM,JPRB

IMPLICIT NONE


REAL(KIND=JPRB), SAVE ::   rter=6371229._JPRB
REAL(KIND=JPRB), SAVE ::   gg=9.80665_JPRB
REAL(KIND=JPRB), SAVE ::   ra=287.05_JPRB
REAL(KIND=JPRB), SAVE ::   cp=1005.46_JPRB
REAL(KIND=JPRB), SAVE ::   t00=273.16_JPRB
REAL(KIND=JPRB), SAVE ::   xp0=100000._JPRB
REAL(KIND=JPRB), SAVE ::   ts=288._JPRB
REAL(KIND=JPRB), SAVE ::   r0=2.55e+19_JPRB
REAL(KIND=JPRB), SAVE ::   pref= 101325._JPRB
 
END MODULE cstphy_module
