!  ASIS method 0D Fortran code demonstrator
!
!  Reference:
!    ASIS v1.0: an adaptative solver for the simulation of atmospheric chemistry
!    Daniel Cariolle, Philippe Moinat, Hubert Teyssèdre, Luc Giraud, Béatrice Josse, and Franck Lefèvre
!    Geosci. Model Dev. Discuss., doi:10.5194/gmd-2016-281, 2016
!    Manuscript accepted for publication in the journal Geosci. Model Dev.
!    Published: 21 November 2016
!
!  BASIC TYPES
!
MODULE TYPES

IMPLICIT NONE

INTEGER, PARAMETER :: JPIM = 4   ! for INTEGER
INTEGER, PARAMETER :: JPRB = 8   ! for REAL

! Z3SPEC type is used to describe  Alpha A --> Gamma G + Zeta Z   reactions
!	z1=Alpha  z2=A index, z3=Gamma  z4=G index, z5=Zeta  z6=Z index 
TYPE Z3SPEC
	REAL(KIND=JPRB)    :: z1
	INTEGER(KIND=JPIM) :: z2
	REAL(KIND=JPRB)    :: z3
	INTEGER(KIND=JPIM) :: z4
	REAL(KIND=JPRB)    :: z5
	INTEGER(KIND=JPIM) :: z6
END TYPE Z3SPEC

! Z4SPEC type is used to describe  Alpha A + Beta B --> Gamma G + Zeta Z   reactions
!	z1=Alpha  z2=A index, z3=Beta  z4=B index , z5=Gamma  z8=G index, z7=Zeta  z8=Z index 
TYPE Z4SPEC
	REAL(KIND=JPRB)    :: z1
	INTEGER(KIND=JPIM) :: z2
	REAL(KIND=JPRB)    :: z3
	INTEGER(KIND=JPIM) :: z4
	REAL(KIND=JPRB)    :: z5
	INTEGER(KIND=JPIM) :: z6
	REAL(KIND=JPRB)    :: z7
	INTEGER(KIND=JPIM) :: z8
END TYPE Z4SPEC

END MODULE TYPES
